"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import luminarycloud._proto.base.base_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _ReferenceValueType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ReferenceValueTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ReferenceValueType.ValueType], builtins.type):  # noqa: F821
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    REFERENCE_VALUES_INVALID: _ReferenceValueType.ValueType  # 0
    REFERENCE_PRESCRIBE_VALUES: _ReferenceValueType.ValueType  # 1
    REFERENCE_FARFIELD_VALUES: _ReferenceValueType.ValueType  # 2

class ReferenceValueType(_ReferenceValueType, metaclass=_ReferenceValueTypeEnumTypeWrapper): ...

REFERENCE_VALUES_INVALID: ReferenceValueType.ValueType  # 0
REFERENCE_PRESCRIBE_VALUES: ReferenceValueType.ValueType  # 1
REFERENCE_FARFIELD_VALUES: ReferenceValueType.ValueType  # 2
global___ReferenceValueType = ReferenceValueType

class ReferenceValues(google.protobuf.message.Message):
    """Define reference values needed for computing forces, moments and other non-dimensional output quantities."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REFERENCE_VALUE_TYPE_FIELD_NUMBER: builtins.int
    AREA_REF_FIELD_NUMBER: builtins.int
    LENGTH_REF_FIELD_NUMBER: builtins.int
    USE_AERO_MOMENT_REF_LENGTHS_FIELD_NUMBER: builtins.int
    LENGTH_REF_PITCH_FIELD_NUMBER: builtins.int
    LENGTH_REF_ROLL_FIELD_NUMBER: builtins.int
    LENGTH_REF_YAW_FIELD_NUMBER: builtins.int
    P_REF_FIELD_NUMBER: builtins.int
    T_REF_FIELD_NUMBER: builtins.int
    V_REF_FIELD_NUMBER: builtins.int
    reference_value_type: global___ReferenceValueType.ValueType
    """Method of specification for the reference values used in force and moment computations."""
    @property
    def area_ref(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference area for computing force and moment coefficients."""
    @property
    def length_ref(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference length for computing moment coefficients."""
    use_aero_moment_ref_lengths: builtins.bool
    """Separate reference lengths for pitching, rolling and yawing moments."""
    @property
    def length_ref_pitch(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference length for computing pitching moment coefficients."""
    @property
    def length_ref_roll(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference length for computing rolling moment coefficients."""
    @property
    def length_ref_yaw(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference length for computing yawing moment coefficients."""
    @property
    def p_ref(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Absolute static reference pressure for computing force and moment coefficients. This value is independent of the simulation reference pressure."""
    @property
    def t_ref(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference temperature for computing force and moment coefficients."""
    @property
    def v_ref(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Reference velocity magnitude for computing force and moment coefficients."""
    def __init__(
        self,
        *,
        reference_value_type: global___ReferenceValueType.ValueType = ...,
        area_ref: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        length_ref: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        use_aero_moment_ref_lengths: builtins.bool = ...,
        length_ref_pitch: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        length_ref_roll: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        length_ref_yaw: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        p_ref: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        t_ref: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        v_ref: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["area_ref", b"area_ref", "length_ref", b"length_ref", "length_ref_pitch", b"length_ref_pitch", "length_ref_roll", b"length_ref_roll", "length_ref_yaw", b"length_ref_yaw", "p_ref", b"p_ref", "t_ref", b"t_ref", "v_ref", b"v_ref"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["area_ref", b"area_ref", "length_ref", b"length_ref", "length_ref_pitch", b"length_ref_pitch", "length_ref_roll", b"length_ref_roll", "length_ref_yaw", b"length_ref_yaw", "p_ref", b"p_ref", "reference_value_type", b"reference_value_type", "t_ref", b"t_ref", "use_aero_moment_ref_lengths", b"use_aero_moment_ref_lengths", "v_ref", b"v_ref"]) -> None: ...

global___ReferenceValues = ReferenceValues
